Attribute VB_Name = "Module1"
Option Explicit

Public Type Point
    X As Long
    Y As Long
    Color As Long
End Type

Public Type Triangle
    Vertices(0 To 2) As Point
    Indices(0 To 2) As Long
    CenterX As Single
    CenterY As Single
    Radius As Single
    Valid As Long
End Type

Public Triangles() As Triangle
Public ValidTris() As Long

Public Function GetMin(ByVal A As Long, ByVal B As Long, ByVal C As Long) As Long

Dim Smallest As Long

Smallest = A
If Smallest > B Then Smallest = B
If Smallest > C Then Smallest = C

GetMin = Smallest

End Function

Public Function GetMax(ByVal A As Long, ByVal B As Long, ByVal C As Long) As Long

Dim Largest As Long

Largest = A
If Largest < B Then Largest = B
If Largest < C Then Largest = C

GetMax = Largest

End Function

Public Function Binomial(ByVal n As Long, ByVal k As Long) As Long
 
Dim i As Long
Dim P As Long

P = 1

For i = 1 To k
    P = P * n / i
    n = n - 1
Next

Binomial = P
 
End Function

Public Sub DoDelaunay(ByRef MyRobots As ListOfRobot)

Dim i As Long
Dim j As Long
Dim k As Long
Dim Counter As Long
Dim NumTris As Long
Dim UBTris As Long
Dim Radius As Single
Dim A As Single
Dim B As Single
Dim C As Single
Dim D As Single
Dim E As Single
Dim F As Single
Dim G As Single
Dim dX As Single
Dim dY As Single
Dim MinX As Long
Dim MinY As Long
Dim MaxX As Long
Dim MaxY As Long
Dim ThisDistance As Single
Dim UBValid As Long

If MyRobots.Count < 3 Then
    ReDim ValidTris(0 To 0) As Long
    Exit Sub
End If

NumTris = Binomial(MyRobots.Count, 3)
UBTris = NumTris - 1

ReDim Triangles(0 To UBTris) As Triangle

For i = 0 To MyRobots.Count - 1
    For j = i + 1 To MyRobots.Count - 1
        For k = j + 1 To MyRobots.Count - 1
            Triangles(Counter).Vertices(0).X = MyRobots.Arr(i).Location.X
            Triangles(Counter).Vertices(0).Y = MyRobots.Arr(i).Location.Y
            Triangles(Counter).Vertices(0).Color = MyRobots.Arr(i).Element.FillColor

            Triangles(Counter).Vertices(1).X = MyRobots.Arr(j).Location.X
            Triangles(Counter).Vertices(1).Y = MyRobots.Arr(j).Location.Y
            Triangles(Counter).Vertices(1).Color = MyRobots.Arr(j).Element.FillColor

            Triangles(Counter).Vertices(2).X = MyRobots.Arr(k).Location.X
            Triangles(Counter).Vertices(2).Y = MyRobots.Arr(k).Location.Y
            Triangles(Counter).Vertices(1).Color = MyRobots.Arr(k).Element.FillColor

            Triangles(Counter).Indices(0) = i
            Triangles(Counter).Indices(1) = j
            Triangles(Counter).Indices(2) = k

            Triangles(Counter).Valid = 1

            Counter = Counter + 1
        Next
    Next
Next

For i = 0 To UBTris
    A = Triangles(i).Vertices(1).X - Triangles(i).Vertices(0).X
    B = Triangles(i).Vertices(1).Y - Triangles(i).Vertices(0).Y
    C = Triangles(i).Vertices(2).X - Triangles(i).Vertices(0).X
    D = Triangles(i).Vertices(2).Y - Triangles(i).Vertices(0).Y
    E = (A * (Triangles(i).Vertices(0).X + Triangles(i).Vertices(1).X)) + (B * (Triangles(i).Vertices(0).Y + Triangles(i).Vertices(1).Y))
    F = (C * (Triangles(i).Vertices(0).X + Triangles(i).Vertices(2).X)) + (D * (Triangles(i).Vertices(0).Y + Triangles(i).Vertices(2).Y))
    G = 2 * (A * (Triangles(i).Vertices(2).Y - Triangles(i).Vertices(1).Y) - B * (Triangles(i).Vertices(2).X - Triangles(i).Vertices(1).X))

    If Abs(G) < 0.000001 Then
        MinX = GetMin(Triangles(i).Vertices(0).X, Triangles(i).Vertices(1).X, Triangles(i).Vertices(2).X)
        MinY = GetMin(Triangles(i).Vertices(0).Y, Triangles(i).Vertices(1).Y, Triangles(i).Vertices(2).Y)
        MaxX = GetMax(Triangles(i).Vertices(0).X, Triangles(i).Vertices(1).X, Triangles(i).Vertices(2).X)
        MaxY = GetMax(Triangles(i).Vertices(0).Y, Triangles(i).Vertices(1).Y, Triangles(i).Vertices(2).Y)
        
        Triangles(i).CenterX = (MinX + MaxX) / 2
        Triangles(i).CenterY = (MinY + MaxY) / 2
        
        dX = Triangles(i).CenterX - MinX
        dY = Triangles(i).CenterY - MinY
    Else
        Triangles(i).CenterX = ((D * E) - (B * F)) / G
        Triangles(i).CenterY = ((A * F) - (C * E)) / G
        
        dX = Triangles(i).CenterX - Triangles(i).Vertices(0).X
        dY = Triangles(i).CenterY - Triangles(i).Vertices(0).Y
    End If
    
    If Abs(dX) < &H7FFF And Abs(dY) < &H7FFF Then
        Triangles(i).Radius = Sqr((dX * dX) + (dY * dY))
    Else
        Triangles(i).Radius = &H3FFFFFFF
    End If
Next

For i = 0 To UBTris
    For j = 0 To MyRobots.Count - 1
        If j <> Triangles(i).Indices(0) And j <> Triangles(i).Indices(1) And j <> Triangles(i).Indices(2) Then
            ThisDistance = Sqr(((Triangles(i).CenterX - MyRobots.Arr(j).Location.X) * (Triangles(i).CenterX - MyRobots.Arr(j).Location.X)) + ((Triangles(i).CenterY - MyRobots.Arr(j).Location.Y) * (Triangles(i).CenterY - MyRobots.Arr(j).Location.Y)))
            
            If ThisDistance < Triangles(i).Radius Then 'j lies inside, therefore i is not a valid triangle.
                Triangles(i).Valid = 0
                Exit For
            End If
        End If
    Next
Next

ReDim ValidTris(0 To UBTris) As Long
k = 0
For i = 0 To UBTris
    If Triangles(i).Valid Then
        ValidTris(k) = i
        k = k + 1
    End If
Next
UBValid = k - 1
If UBValid >= 0 Then ReDim Preserve ValidTris(0 To UBValid) As Long

End Sub
















